<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en" xml:lang="en">

<head>
  <title>KNS.Engine</title>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
  <meta http-equiv="Content-Style-Type" content="text/css" />
  <link rel="stylesheet" type="text/css" href="../common/doxygen.css" />
  <link rel="stylesheet" media="screen" type="text/css" title="KDE Colors" href="../common/kde.css" />
</head>
<body>
<div id="container">
<div id="header">
  <div id="header_top">
    <div>
      <div>
        <img alt ="" src="../common/top-kde.jpg"/>
        KDE 4.2 PyKDE API Reference
      </div>
    </div>
  </div>
  <div id="header_bottom">
    <div id="location">
      <ul>
        <li>KDE's Python API</li>
      </ul>
    </div>

    <div id="menu">
      <ul>
        <li><a href="../modules.html">Overview</a></li>
<li><a href="http://techbase.kde.org/Development/Languages/Python">PyKDE Home</a></li>
<li><a href="http://kde.org/family/">Sitemap</a></li>
<li><a href="http://kde.org/contact/">Contact Us</a></li>
</ul>
    </div>
  </div>
</div>

<div id="body_wrapper">
<div id="body">
<div id="right">
<div class="content">
<div id="main">
<div class="clearer">&nbsp;</div>

<h1>Engine Class Reference</h1>
<code>from PyKDE4.knewstuff import *</code>
<p>


Namespace: KNS<br />
<h2>Detailed Description</h2>

<p>The KNewStuff2 engine is the top-level class to handle GHNS and DXS workflows.
</p>
<p>
An engine implements GHNS workflows, which consist of discrete steps
performed by the inherited engine. Depending on the provider, traditional
GHNS or DXS are used transparently.
This class is the one which applications should use.
In most cases, either upload() or download() will be called by the
application to upload or download data.
</p>
<table border="0" cellpadding="0" cellspacing="0"><tr><td colspan="2"><br><h2>Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj199715212">__init__</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a> parent=0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj184784972">__init__</a> (self, <a href="../knewstuff/KNS.Engine.html">KNS.Engine</a> a0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj197895340">downloadDialog</a> (self)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">KNS.Entry.List&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj199713676">downloadDialogModal</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a> parent=0)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">bool&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj201225932">init</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> config)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj197895916">uploadDialog</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> file)</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../knewstuff/KNS.Entry.html">KNS.Entry</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj169956108">uploadDialogModal</a> (self, <a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> file)</td></tr>
<tr><td colspan="2"><br><h2>Static Methods</h2></td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top">KNS.Entry.List&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj169955596">download</a> ()</td></tr>
<tr><td class="memItemLeft" nowrap align="right" valign="top"><a href="../knewstuff/KNS.Entry.html">KNS.Entry</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="#obj197897516">upload</a> (<a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a> file)</td></tr>
</table>
<hr><h2>Method Documentation</h2><a class="anchor" name="obj199715212"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a>&nbsp;</td>
<td class="paramname"><em>parent=0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Engine constructor.
</p>
<p>
As many engines as needed can be instantiated, although one should use
the static methods download() and upload() instead.
</p></div></div><a class="anchor" name="obj184784972"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">__init__</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="../knewstuff/KNS.Engine.html">KNS.Engine</a>&nbsp;</td>
<td class="paramname"><em>a0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj169955596"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">KNS.Entry.List download</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname">)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Recommended download workflow entry point.
</p>
<p>
This method is a static convenience wrapper around downloadDialogModal()
which does not require the manual construction of an engine object.
The engine will be configured to load appname.knsrc.
The resulting entry list must not be freed, as the engine will continue
to keep track of it.
</p>
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd> List of installed or deinstalled entries
NOTE: this is a copy of each entry because this call deletes its own
engine which deletes the original entries, so you need to delete the entries
returned in the list
</dd></dl> </p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> downloadDialogModal()
</dd></dl>
</p></div></div><a class="anchor" name="obj197895340"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> downloadDialog</td>
<td>(</td>
<td class="paramtype">&nbsp;</td>
<td class="paramname"><em>self</em>&nbsp;)</td>
<td width="100%"> </td>
</tr>
</table>
</div>
<div class="memdoc"><p>Asynchronous way of starting the download workflow.
</p>
<p>
This method should be used whenever a blocking application with a
non-blocking GUI during GHNS operations is not suitable.
Affected entries will be reported by signals.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> downloadDialogModal()
</dd></dl>
</p></div></div><a class="anchor" name="obj199713676"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">KNS.Entry.List downloadDialogModal</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qwidget.html">QWidget</a>&nbsp;</td>
<td class="paramname"><em>parent=0</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Synchronous way of starting the download workflow.
</p>
<p>
Starts the download workflow. This workflow will turn up a dialog
where the user can select entries for installation and uninstallation.
This method is a modal one. It will return all affected entries as
a list.
</p>
<p>
NOTE: this list must be queried to see which ones were installed and which were uninstalled
since both are in the one list. i.e. (entry-&gt;status() == KNS.Entry.Installed)
NOTE: the list returned is not a copy of each entry, so do not delete the entries returned here
</p>
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd> List of installed or deinstalled entries
</dd></dl>
</p></div></div><a class="anchor" name="obj201225932"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname">bool init</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>config</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"></div></div><a class="anchor" name="obj197897516"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../knewstuff/KNS.Entry.html">KNS.Entry</a> upload</td>
<td>(</td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>file</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Recommended upload workflow entry point.
</p>
<p>
This method is a static convenience wrapper around uploadDialogModal()
which does not require the manual construction of an engine object.
The engine will be configured to load appname.knsrc.
The resulting entry must not be freed, as the engine will continue
to keep track of it.
</p>
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd> Uploaded entry, or <b>null</b> in case of failures
</dd></dl> </p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> uploadDialogModal()
</dd></dl>
</p></div></div><a class="anchor" name="obj197895916"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"> uploadDialog</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>file</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Asynchronous way of starting the upload workflow.
</p>
<p>
This method should be used whenever a blocking application with a
non-blocking GUI during GHNS operations is not suitable.
The affected entry will be reported by signals.
</p>
<p>
<dl class="see" compact><dt><b>See also:</b></dt><dd> uploadDialogModal()
</dd></dl>
</p></div></div><a class="anchor" name="obj169956108"></a>
<div class="memitem">
<div class="memproto">
<table class="memname"><tr>
<td class="memname"><a href="../knewstuff/KNS.Entry.html">KNS.Entry</a> uploadDialogModal</td>
<td>(</td>
<td class="paramtype">&nbsp;<em>self</em>, </td>
<td class="paramname"></td>
</tr><tr>
<td class="memname"></td>
<td></td>
<td class="paramtype"><a href="http://www.riverbankcomputing.co.uk/static/Docs/PyQt4/html/qstring.html">QString</a>&nbsp;</td>
<td class="paramname"><em>file</em></td>
</tr>
<tr>
<td></td>
<td>)</td>
<td></td>
<td></td>
<td width="100%"> </td>
</tr></table>
</div>
<div class="memdoc"><p>Synchronous way of starting the upload workflow.
</p>
<p>
Starts the upload workflow. This workflow will offer provider
selection and afterwards upload all files associated with an entry.
This method is a modal one. It will return the uploaded entry.
</p>
<p>
<dl class="return" compact><dt><b>Returns:</b></dt><dd> Uploaded entry, or <b>null</b> in case of failures
</dd></dl>
</p></div></div>
</div>
</div>
</div>

<div id="left">

<div class="menu_box">
<div class="nav_list">
<ul>
<li><a href="../allclasses.html">Full Index</a></li>
</ul>
</div>

<a name="cp-menu" /><div class="menutitle"><div>
  <h2 id="cp-menu-project">Modules</h2>
</div></div>
<div class="nav_list">
<ul>
<li><a href="../akonadi/index.html">akonadi</a></li>
<li><a href="../dnssd/index.html">dnssd</a></li>
<li><a href="../kdecore/index.html">kdecore</a></li>
<li><a href="../kdeui/index.html">kdeui</a></li>
<li><a href="../khtml/index.html">khtml</a></li>
<li><a href="../kio/index.html">kio</a></li>
<li><a href="../knewstuff/index.html">knewstuff</a></li>
<li><a href="../kparts/index.html">kparts</a></li>
<li><a href="../kutils/index.html">kutils</a></li>
<li><a href="../nepomuk/index.html">nepomuk</a></li>
<li><a href="../phonon/index.html">phonon</a></li><li><a href="../plasma/index.html">plasma</a></li>
<li><a href="../solid/index.html">solid</a></li>
<li><a href="../soprano/index.html">soprano</a></li>
</ul></div></div>

</div>

</div>
  <div class="clearer"/>
</div>

<div id="end_body"></div>
</div>
<div id="footer"><div id="footer_text">
This documentation is maintained by <a href="&#109;&#97;&#105;&#108;&#116;&#111;&#58;simon&#64;simonzone&#46;com">Simon Edwards</a>.<br />
        KDE<sup>&#174;</sup> and <a href="../images/kde_gear_black.png">the K Desktop Environment<sup>&#174;</sup> logo</a> are registered trademarks of <a href="http://ev.kde.org/" title="Homepage of the KDE non-profit Organization">KDE e.V.</a> |
        <a href="http://www.kde.org/contact/impressum.php">Legal</a>
    </div></div>
</body>
</html>
